package sb::Plugin::RealTimeHolidayCalendar;

use sb::Plugin ();

sb::Plugin->register_plugin(
    'lang' => {
        'ja' => 'euc',
        'en' => 'ascii',
    },
    'text' => {
        'type'    => 'cms',
        'name'    => 'RealTimeHolidayCalendar2',
        'text'    => 'script for RealTime Holiday Calendar of horizontal type',
        'author'  => 'yujiro',
        'detail'  => 'http://www.koikikukan.com/',
        'version' => '1.00',
    },
    'data' => 0,
    'file' => 'realtime_holidaycalendar2.txt',
);

sb::Plugin->register_content_module(
    'type'     => 'main',
    'callback' => \&sb::Content::RealTimeHolidayCalendar::_real_time_holiday_calendar,
    'field'    => 'rt_holiday_calendar',
);

package sb::Content::RealTimeHolidayCalendar;

sub _real_time_holiday_calendar {
    my $cms = shift;
    my %var = @_;
    my $data = <<EOF;

<script type="text/javascript">
<!--
function setWeekendAndHoliday() {
    var id = 'rt_holiday_calendar';

    // check year and month
    var element = document.getElementById(id);
    if(!element){
        return;
    }
    var link = element.getElementsByTagName('a')[0].getAttribute('href');
    var ym = link.split('=')[1];
    var year = ym.substring(0, 4);
    var month = ym.substring(4);
    if (month == '12') {
        month = '01';
        year++;
    } else {
        month++;
        if (month < 10) {
            month = '0' + month.toString();
        }
    }
    buf = element.innerHTML;

    // delete span
    buf = buf.replace(/<span class="today">(\\d+)<\\/span>/gi,"\$1");
    buf = buf.replace(/<span class=today>(\\d+)<\\/span>/gi,"\$1"); // for IE

    // add span
    buf = buf.replace(/\\s(\\d+)\\s/gi," <span class=\\"day\\">\$1<\\/span> ");
    buf = buf.replace(/\\s(\\d+)\\s/gi," <span class=\\"day\\">\$1<\\/span> ");
    buf = buf.replace(/\\s(<a\\s\\S+>\\d+<\\/a>)\\s/gi," <span class=\\"day\\">\$1<\\/span> ");
    buf = buf.replace(/\\s(<a\\s\\S+>\\d+<\\/a>)\\s/gi," <span class=\\"day\\">\$1<\\/span> ");
    element.innerHTML = buf;

    var spans = element.getElementsByTagName("span");
    var day;

    for (i = 0; i < spans.length; i++) {
        if (spans[i].getAttribute("class") == "day" ||
             spans[i].getAttribute("className") == "day") {
            if(spans[i].innerHTML.indexOf("href") != -1){
                day = spans[i].getElementsByTagName("a")[0].innerHTML;
            } else {
                day = spans[i].innerHTML;
            }
            if (isHoliday(year, month, day)) {
                if (isToday(year, month, day)) {
                    spans[i].setAttribute('class', 'tholiday');
                    spans[i].setAttribute('className', 'tholiday');
                } else {
                    spans[i].setAttribute('class', 'holiday');
                    spans[i].setAttribute('className', 'holiday');
                }
            } else if(isSaturday(year, month, day)) {
                if (isToday(year, month, day)) {
                    spans[i].setAttribute('class', 'tsaturday');
                    spans[i].setAttribute('className', 'tsaturday');
                } else {
                    spans[i].setAttribute('class', 'saturday');
                    spans[i].setAttribute('className', 'saturday');
                }
            } else if (isToday(year, month, day)) {
                spans[i].setAttribute('class', 'today');
                spans[i].setAttribute('className', 'today');
            }
        }
    }
}
setCurrentDate();
setWeekendAndHoliday();
//-->
</script>
EOF
    $cms->tag('rt_holiday_script' => $data);
    $cms->tag('rt_holiday_calendar_script' => '<script type="text/javascript" src="'.$var{'conf'}->value('conf_srv_base').'dayChecker.js" charset="utf-8"></script>');
    return 1;
}

1;
__END__
